#include <stdio.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <stdlib.h>
#include <wchar.h>
#include <math.h>
#include <string.h>
#include <errno.h>


float condert_char_buffer_to_double(char *char_coeff, int char_coeff_index)
{
    int to_num = 1;
    double temp_coeff = 0;
    int point_index = 0;
    char_coeff = realloc(char_coeff, sizeof(char) * char_coeff_index);
    char_coeff[char_coeff_index] = '\0';
    for (size_t i = 0; i < char_coeff_index; i++)
    {
        if (char_coeff[i] == '.')
        {
            point_index = i;
        }
        else
        {
            temp_coeff = temp_coeff * to_num + (char_coeff[i] - '0');
            to_num *= 10;
        }
    }
    int delitel = 1;
    if (point_index != 0)
    {
        for (size_t i = 0; i < (char_coeff_index - 1) - point_index; i++)
        {
            delitel *= 10;
        }
    }
    temp_coeff /= delitel;
    return temp_coeff;
}

int convert_coeff(char *buffer, float **array_coeff)
{
    int array_coeff_index = 0;
    char *char_coeff = malloc(sizeof(char) * 100);
    int main_while_index = 0;
    int char_coeff_index = 0;
    int minus = 0;
    while (1)
    {
        if (buffer[main_while_index] != ' ' && buffer[main_while_index] != '\n' && buffer[main_while_index] != '\r' && buffer[main_while_index] != '\0')
        {
            
            char_coeff[char_coeff_index] = buffer[main_while_index];
            char_coeff_index++;
        }
        else
        {
            if (buffer[main_while_index + 1] == ' ' || buffer[main_while_index] == '\n' || buffer[main_while_index] == '\r')
            {
                return 1;
            }
            else if (!(char_coeff[char_coeff_index - 1] >= '0' && char_coeff[char_coeff_index - 1] <= '9'))
            {
                return 1;
            }
            else if (char_coeff[0] == '-')
            {
                minus = 1;
            }
            int count_point = 0;
            for (size_t i = 0; i < char_coeff_index; i++)
            {
                if (char_coeff[i] >= '0' && char_coeff[i] <= '9' || char_coeff[i] == '-')
                {
                    continue;
                }
                else
                {
                    if (char_coeff[i] == '.' && count_point <= 0)
                    {
                        count_point++;
                    }
                    else
                    {
                        return 1;
                    }
                }
            }
            char_coeff = realloc(char_coeff, sizeof(char) * char_coeff_index);
            char_coeff[char_coeff_index] = '\0';
            if (minus)
            {
                for (size_t i = 0; i < char_coeff_index - 1; i++)
                {
                    char_coeff[i] = char_coeff[i + 1];
                }
                char_coeff = realloc(char_coeff, sizeof(char) * (char_coeff_index - 1));
                (*array_coeff)[array_coeff_index] = condert_char_buffer_to_double(char_coeff, char_coeff_index - 1) * -1;
            }
            else
                (*array_coeff)[array_coeff_index] = condert_char_buffer_to_double(char_coeff, char_coeff_index);
            array_coeff_index++;
            char_coeff = malloc(sizeof(char) * 100);
            char_coeff_index = 0;
            minus = 0;
        }
        main_while_index++;
        if (buffer[main_while_index - 1] == '\0') break;

    }
    if (array_coeff_index != 3)
    {
        return 2;
    }
    return 0;
}

int count_coefficient(float *coefficient, float **coefficient_answer)
{
    if (coefficient[1] == 0 && coefficient[2] == 0)
    {
        coefficient_answer[0] = 0;
        coefficient_answer[1] = 0;
        return 0;
    }
    else if (coefficient[1] == 0)
    {
        if (coefficient[2] * -1 / coefficient[0] < 0)
        {
            return 1;
        }
        else
        {

            (*coefficient_answer)[0] = sqrt(coefficient[2] * -1 / coefficient[0]);
            (*coefficient_answer)[1] = sqrt(coefficient[2] * -1 / coefficient[0]) * -1;
            return 0;
        }
    }
    else if (coefficient[2] == 0)
    {
        (*coefficient_answer)[0] = 0;
        (*coefficient_answer)[1] = coefficient[1] * -1 / coefficient[0];
        return 0;
    }
    else if (coefficient[0] == 0)
    {
        return 1;
    }
    else
    {
        float *temp_array = realloc((*coefficient_answer), sizeof(float) * 3);
        float D = pow(coefficient[1], 2) - 4 * coefficient[0] * coefficient[2];
        temp_array[0] = D;
        if (D < 0)
        {
            return 1;
        }
        else if (D == 0)
        {
            temp_array[1] = (coefficient[1] * -1) / (2 * coefficient[0]);
            *coefficient_answer = temp_array;
            return 2;
        }
        else
        {
            temp_array[1] = ((coefficient[1] * -1) + sqrt(D)) / (2 * coefficient[0]);
            temp_array[2] = ((coefficient[1] * -1) - sqrt(D)) / (2 * coefficient[0]);
            *coefficient_answer = temp_array;

            return 3;
        }
    }
}

int write_in_file(int result_code, float *coefficient_answer)
{
    int file = open("answer.txt", O_RDWR | O_CREAT | O_TRUNC, S_IRWXU  );
    if (file == -1) {
        printf("bad");

    }
    else {
        printf("good");
    }
    printf("%d", file);
    char* buffer = calloc(sizeof(char),200);
    wchar_t wbuffer[300];
    int wchars = 0;
    switch (result_code)
    {
    case 0:
        sprintf(buffer, "Данное уравнение было решено без дискриминанта\nПервый корень - % .4f\nВторой корень - % .4f\0", coefficient_answer[0], coefficient_answer[1]);
        buffer[strlen(buffer)] = '\0';
        if (write(file, buffer, strlen(buffer)) != 1)
        {
        }
        else
        {
            printf("Код ошибки: %d\n", errno);
        }
        break;
    case 1:
        sprintf(buffer, "Уравнение не имеет корней\0");
        buffer[strlen(buffer)] = '\0';
        wchars = mbstowcs(wbuffer, buffer, strlen(buffer) + 1);
        if (write(file, buffer, strlen(buffer)) != 1)
        {
        }
        else
        {
            printf("Код ошибки: %d\n", errno);
        }
        break;
    case 2:
        sprintf(buffer, "дискриминанта равен %.4f, поэтому у уравнения один корень\nКорень - %.4f\0", coefficient_answer[0], coefficient_answer[1]);
        buffer[strlen(buffer)] = '\0';
        wchars = mbstowcs(wbuffer, buffer, strlen(buffer) + 1);
        if (write(file, buffer, 200) != 1)
        {
        }
        else
        {
            printf("Код ошибки: %d\n", errno);

        }
        break;
    case 3:
        sprintf(buffer, "дискриминанта равен %.4f\nПервый корень - %.4f\nВторой корень - %.4f\0", coefficient_answer[0], coefficient_answer[1], coefficient_answer[2]);
        buffer[strlen(buffer)] = '\0';
        wchars = mbstowcs(wbuffer, buffer, strlen(buffer) + 1);
        if (write(file, buffer, 200) != 1)
        {
        }
        else
        {
            printf("Код ошибки: %d\n", errno);

        }
        break;
    default:
        break;
    }
}

int main()
{
    char *buffer = malloc(sizeof(char) * 200);
    int file = open("coeff", O_RDONLY | O_CREAT);
    ssize_t count = read(file, buffer, 200);
    close(file);
    if (count != -1)
    {
        buffer = realloc(buffer, sizeof(char) * count);
        buffer[count] = '\0';
        float *array_coeff = malloc(sizeof(float) * 3);
        if (convert_coeff(buffer, &array_coeff))
        {
            printf("Неккоректный код");
            return 1;
        }
        float *coefficient_answer = malloc(sizeof(float) * 2);
        int code = count_coefficient(array_coeff, &coefficient_answer);
        write_in_file(code, coefficient_answer);
    }
    return 0;
}